// thread1.cpp
// Glenn G. Chappell
// 4 Feb 2013
//
// For CS 321 Spring 2013
// Basic C++11 Threads

#include <iostream>
using std::cout;
using std::endl;
#include <thread>
using std::thread;


// Run function for spawned threads
void run(int n)
{
    // Give the scheduler something to play with
    int j = 0;
    for (int i = 0; i < 1000000; ++i)
        ++j;

    // Now print our number and terminate
    cout << "Slave: This is thread #" << n << endl;
}


int main()
{
    cout << "Master: Spawning 4 threads, joining 1 & 2, detaching 3 & 4"
         << endl;
    thread t1(run, 1);  // Spawn
    thread t2(run, 2);
    thread t3(run, 3);
    thread t4(run, 4);

    t1.join();  // Each spawned thread must be joined or detached
    t2.join();
    t3.detach();
    t4.detach();

    return 0;
}

